#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define MAZE_WIDTH      30
#define MAZE_HEIGHT     20
#define TILE_SIZE       20
#define WALL_WIDTH      2

#define SCREEN_WIDTH    (MAZE_WIDTH  * TILE_SIZE + WALL_WIDTH)
#define SCREEN_HEIGHT   (MAZE_HEIGHT * TILE_SIZE + WALL_WIDTH)

void drawWall(int x, int y, bool isHorizontal, Color c)
{
    int sx = x * TILE_SIZE;
    int sy = y * TILE_SIZE;

    if (isHorizontal == true)
    {
        int ex = sx + TILE_SIZE - 1;
        int ey = sy + WALL_WIDTH - 1;

        for (int yy = sy; yy <= ey; yy++)
            for (int xx = sx; xx <= ex; xx++)
                gfx.setPixel(xx, yy, c);
    }
    else
    {
        int ex = sx + WALL_WIDTH - 1;
        int ey = sy + TILE_SIZE + WALL_WIDTH - 1;

        for (int yy = sy; yy <= ey; yy++)
            for (int xx = sx; xx <= ex; xx++)
                gfx.setPixel(xx, yy, c);
    }
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Tree Maze", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0));

    // draw the maze
    for (int y = 0; y < MAZE_HEIGHT; y++)
        for (int x = 0; x < MAZE_WIDTH; x++)
        {
            drawWall(x, y, false, Color(255, 255, 255));
            drawWall(x, y, true,  Color(255, 255, 255));
        }

    for (int y = 0; y < MAZE_HEIGHT; y++)
        drawWall(MAZE_WIDTH, y, false, Color(255, 255, 255));

    for (int x = 0; x < MAZE_WIDTH; x++)
        drawWall(x, MAZE_HEIGHT, true, Color(255, 255, 255));

    // wait till the end
    while (sys.isQuitRequested() == false)
    {
        sys.processEvents();
        gfx.render();
        sys.wait(50);
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
